#include "app.h"

unsigned char hex2byte(char** cs) {
	register unsigned int a;
	register unsigned int b;
	
	a = (*(*cs)++) - '0';
	if( a > 9 )
		a -= 7;	
	b = (*(*cs)++) - '0';
	if( b > 9 )
		b -= 7;
		
	a<<=1;a<<=1;a<<=1;a<<=1;	// not unsing library bitshift
	b |= a;
	return( b );
}
unsigned int hex2word(char** cs) {
	register unsigned int w;
	register unsigned int b;
	register unsigned int cnt = 3;
	
	w = (*(*cs)++) - '0';
	if( w > 9 )
		w -= 7;
 hex2word_halfbyte:
	b = (*(*cs)++) - '0';
	if( b > 9 )
		b -= 7;
	w<<=1;w<<=1;w<<=1;w<<=1;	// not unsing library bitshift
	w |= b;
	cnt--;
	if( cnt ) goto hex2word_halfbyte;
	
	return w;	
}

void System_setDCO()
{
#if LOADER_WITH_PRINTF
	#define DELTA 1100                   // Target DCO = DELTA(1100)*(4096Hz) , DELTA=550 => 4505600 Hz  */
	#define UP 1                         // Temporary.
	#define DOWN 2                       // Temporary.
	#define DCOLOW  (1)                  // Symbolic name, DCO was last measure too low.
	#define DCOHIGH (2)                  // Symbolic name, DCO was last measure too high.
	#define DCODIFF (3)                  // Difference of dcoDiff to DELTA when DCO measure is taken as too high/low.
	uint16_t Compare, Oldcapture = 0, i, direction = 0;
	// ACLK is devided by 8 = 4096 Hz. RSEL=6 no division for MCLK and SSMCLK. XT2 is off.
	BCSCTL1 = 0xB7;
	// Init FLL to desired frequency using the 32762Hz crystal DCO frquenzy = 2,4576 MHz
	BCSCTL2 = 0x00;
	DCOCTL = 0xFF;
	for ( i = 0xFFFF; i > 0; i-- );   // Delay for XTAL to settle
	CCTL2 = CCIS0 + CM0 + CAP;        // Define CCR2, CAP, ACLK
	TACTL = TASSEL1 + TACLR + MC1;    // SMCLK, continous mode
	while ( 1 ) {
		CCTL2 &= ~( CCIFG + COV );      // clear IFG and possible overflow
		// 1. capture
		while ( !( CCTL2 & CCIFG ) );           // Wait until capture occured!
		CCTL2 &= ~CCIFG;                        // Capture occured, clear flag
		Oldcapture = CCR2;                      // Save current captured SMCLK
		// 2. - 5. capture, "software divider" so aclk stays
		// untouched and 2400 bps are working!
		while ( !( CCTL2 & CCIFG ) );         // Wait until capture occured!
		CCTL2 &= ~CCIFG;                      // Capture occured, clear flag
		Compare = CCR2;
		Compare = Compare - Oldcapture;         // SMCLK difference
		if ( DELTA == Compare ) break;          // if equal, leave "while(1)"
		else {
			if ( DELTA < Compare ) {           // DCO is too fast, slow it down
				if ( direction == UP ) break;    // stop if we were going up (jumped over exact delta)
				if ( !direction ) direction = DOWN; // if starting set direction
				DCOCTL--;
				if ( DCOCTL == 0xFF ) {
					if ( !(( BCSCTL1 & 0x07 ) == 0x00 ) ) WDTCTL = 0xDEAD;
					BCSCTL1--;            // Did DCO role under? -> Select next lower RSEL
				}
			} else {
				if ( direction == DOWN ) break;   // stop if we were going down (jumped over exact delta)
				if ( !direction ) direction = UP; // if starting set direction
				DCOCTL++;
				if ( DCOCTL == 0x00 ) {
					if (( BCSCTL1 & 0x07 ) == 0x07 ) WDTCTL = 0xDEAD;
					BCSCTL1++;            // Did DCO role over? // -> Select next higher RSEL
				}
			}
		}
	}
	CCTL2 = 0;      // Stop CCR2 function
	TACTL = 0;      // Stop Timer_A
#else
    // Basic clock setup, should be a frequency around ~4,5 Mhz.
    DCOCTL = 0xC2;      
    BCSCTL1 = 0x87;
    BCSCTL2 = 0x00;
#endif
}
